﻿---- Différentes composantes issues d'une date
select
getdate() as Now,
DATEADD(dd , -10, getdate()) 			as Now_Moins_10_jours,
DATEADD(mm , -1, getdate()) 			as Now_Moins_1_mois,
DATEADD(yy , -1, getdate()) 			as Now_Moins_1_ans,
DATEPART(ww , getdate())  				as Semaine_Courante,                                                               
MONTH( getdate())  						as Mois_Courant ,                                                                     
DATEPART(qq , getdate())  				as trimestre_Courant,                                                               
YEAR(getdate())  						as Annee_Courante,                                                                        
DATEADD(dd ,DATEDIFF( dd, 0 , getdate()),0) 									as Deb_Jour_Courant,                       
DATEADD(ms , - 3, DATEADD(dd ,DATEDIFF( dd, 0 , getdate()+1), 0)) 				as Fin_Jour_Courant ,
DATEADD(ww ,DATEDIFF( ww, 0 , getdate()),0) 									as Deb_Semaine_Courante,                      
DATEADD(ms , - 3, DATEADD(ww ,DATEDIFF( ww, 0 , DATEADD (ww,+ 1,getdate())),0)) as Fin_Semaine_Courante,    
DATEADD(mm ,DATEDIFF( mm, 0 , getdate()),0) 									as Debut_Mois_Courant,                                         
DATEADD(ms , - 3, DATEADD(mm ,DATEDIFF( mm, 0 , DATEADD (mm,+ 1,getdate())),0)) as Fin_Mois_Courant ,    
DATEADD(yy ,DATEDIFF( yy, 0 , getdate()),0) 									as Debut_Annee_Courante,                                         
DATEADD(ms , - 3, DATEADD(yy ,DATEDIFF( yy, 0 , DATEADD (yy,+ 1,getdate())),0)) as Fin_Annee_Courante;

---- Dates constante dans les requêtes 
---- Si vous êtes amenés à intégrer une date dans votre expression SQL, il faut qu'elle soit sous la forme :
---- CONVERT(datetime,'2013-12-31',112)  pour une date sans heure 
---- ou CONVERT(datetime,'2013-12-31 23:59:59.997',121)  pour une date avec heure
---- Exemple : 
---- case when date_facture between CONVERT(datetime,'2013-01-01 00:00:00.000',121) and CONVERT(datetime,'2013-12-31 23:59:59.997',121) then mtt_fac_net else 0 end

